#procedure makeZtable(j)
*
*	Creates the relations of the type
*		Z(Z(A1,...,Aj),B1,...,Bj)+Z(Z(B1,...,Bj),A1,...,Aj)=0
*	Puts them in the table Ztable`j'.
*
*	First generate all relations:
*
Local relations = D(`j')^2;
repeat id D(i?pos_,?a) = D(i-1,X,?a)+D(i-1,Y,?a);
id,disorder,D(0,?a)*D(0,?b) = 0;
id	D(0,?a)*D(0,?b) = rel(Z(Z(?a),?b)+Z(Z(?b),?a));
makeinteger rel;
DropCoefficient;
.sort:makeZtable;
*
*	Next we expand the relations. This may give the problem that
*   they become too long to be kept inside a single term. Hence
*   we have to mark the relations with a function fcount(number)
*
#$Znumber = 0;
$Znumber = $Znumber+1;
Multiply fcount($Znumber);
id	rel(x?) = x;
repeat id	Z(?a,Z(A?,?b),?c) = Z(?a,A,Z(?b),?c)-Z(?a,Z(?b),A,?c);
id	Z(?a,Z,?b) = Z(?a,X,Y,?b)-Z(?a,Y,X,?b);
*
*	Next we apply the tables for as far as they exist yet.
*	We have to assume that the tables Ztable`i' with
*   0 <= i < j exist.
*
*	An extra complication is that for instance Z(X,Y) = Z(Y,X) will
*	work on all Z(?a,X,Y) and the table has only Ztable(X,Y).
*	Yet another complication is that tables work mostly with
*   numbers. *	This is why we transform first to 1,2 instead of X,Y
*
id	Z(?a) = D*Z(?a);
repeat;
	id	D(?a)*Z(X,?b) = D(?a,1)*Z(?b);
	id	D(?a)*Z(Y,?b) = D(?a,2)*Z(?b);
endrepeat;
id	D(?a)*Z = Z(?a);
B+	fcount;
.sort
#do imakeZtable = 2,2*`j',2
	id	Z(?a,x1?,...,x`imakeZtable'?) =
          D(?a)*Ztable{`imakeZtable'/2-1}(x1,...,x`imakeZtable');
	id	D(?a)*Ztable{`imakeZtable'/2-1}(?b) = Z(?a,?b);
	id	D(?a)*Z(?b) = Z(?a,?b);
	Bracket+ fcount;
	.sort:makeZtable-Use tables-`imakeZtable';
#enddo
*
*	It could be that some relations have become identical.
*	This will get sorted out automatically.
*	We are now going to apply the relations one by one to the others.
*	It is a Gaussian elimination.
*
#do c = 1,`$Znumber'
	#$eq = relations[fcount(`c')];
	#if ( termsin($eq) > 0 )
		#$lhs = firstterm_($eq);
		#inside $lhs
			$coeff = coeff_;
			Dropcoefficient;
		#endinside
		#$rhs = -($eq/($coeff)-$lhs);
		if ( match(fcount(`c')) == 0 )
			id `$lhs' = `$rhs';
		Bracket+ fcount;
		.sort:makeZtable-relation `c';
	#endif
#enddo
NTable,sparse,Ztable`j'({2*`j'+2});
#do c = 1,`$Znumber'
	#$eq = relations[fcount(`c')];
	#if ( termsin($eq) > 0 )
		#$lhs = firstterm_($eq);
		#inside $lhs
			$coeff = coeff_;
			Dropcoefficient;
		#endinside
		#$rhs = -($eq/($coeff)-$lhs);
		#inside $lhs
			Multiply replace_(Z,Ztable`j');
		#endinside
		Fill `$lhs' = `$rhs';
	#endif
#enddo
Drop relations;
.sort:makeZtable-finish;
*
#endprocedure
